package com.example.demo.db.repo;

import java.util.List;
import java.util.Optional;

import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.data.mongodb.repository.Query;
import org.springframework.stereotype.Repository;

import com.example.demo.db.model.TestObject;

@Repository
public interface TestRepository extends MongoRepository<TestObject, String> {

	@Query(value = "?#{ hasRole('ROLE_ADMIN') ? { 'name':'?0' } : { 'name':'?0-trouble' } }")
	Optional<TestObject> findByName(String name);
	
	@Query(value = "{ 'name':'?0' }")
	List<TestObject> findAll(String name);
}
