package com.example.demo;

import static org.junit.jupiter.api.Assertions.assertTrue;

import java.util.Optional;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.data.mongo.DataMongoTest;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.data.repository.query.SecurityEvaluationContextExtension;

import com.example.demo.db.model.TestObject;
import com.example.demo.db.repo.TestRepository;

@DataMongoTest
public class RepoTests {

	@ComponentScan(basePackages = "com.example.demo")
	@Configuration
	public class TestContextConfiguration {

		@Bean
		public SecurityEvaluationContextExtension securityEvaluationContextExtension() {
			return new SecurityEvaluationContextExtension();
		}

	}

	@Autowired
	TestRepository repo;

	@Test
	public void testOne() {

		repo.save(new TestObject("one"));

		Optional<TestObject> thum = repo.findByName("one");
		assertTrue(thum.isPresent(), "Have one");
	}

}
