package com.example.demo;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.jsonPath;
import static org.springframework.test.web.servlet.result.MockMvcResultHandlers.print;

import org.hamcrest.Matchers;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.data.mongo.AutoConfigureDataMongo;
import org.springframework.boot.test.autoconfigure.data.mongo.DataMongoTest;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.result.MockMvcResultMatchers;

import com.example.demo.db.model.TestObject;
import com.example.demo.db.repo.TestRepository;
import com.fasterxml.jackson.databind.ObjectMapper;

@DirtiesContext
@SpringBootTest
@AutoConfigureMockMvc
@AutoConfigureDataMongo
public class RestTests {
	
	@Autowired
	private MockMvc mvc;
	
	@Autowired private TestRepository repo;

	@Autowired
	private ObjectMapper objectMapper;

	private final static String PING = "/ping";

	@Test
	public void pingTest() throws Exception {
		
		repo.findAll();

		mvc.perform(get(PING)).andExpect(MockMvcResultMatchers.status().isOk())
				.andExpect(jsonPath("$", Matchers.notNullValue(TestObject.class)))
				.andDo(print());

	}

}